package org.bidib.wizard.comm;

import org.bidib.jbidibc.enumeration.AnalogPortEnum;
import org.bidib.wizard.locale.Resources;

public enum AnalogPortStatus implements BidibStatus {
    // @formatter:off
    START(AnalogPortEnum.START, Resources.getString(AnalogPortStatus.class, "start"));
    // @formatter:on

    private final AnalogPortEnum type;

    private final String label;

    AnalogPortStatus(AnalogPortEnum type, String label) {
        this.type = type;
        this.label = label;
    }

    public AnalogPortEnum getType() {
        return type;
    }

    public String toString() {
        return label;
    }

    public static AnalogPortStatus valueOf(AnalogPortEnum type) {
        AnalogPortStatus result = null;

        for (AnalogPortStatus e : values()) {
            if (e.type == type) {
                result = e;
                break;
            }
        }
        if (result == null) {
            throw new IllegalArgumentException("cannot map " + type + " to a analog port status");
        }
        return result;
    }
}
