package org.bidib.wizard.comm;

import org.bidib.jbidibc.enumeration.FlagEnum;
import org.bidib.wizard.locale.Resources;

public enum FlagStatus implements BidibStatus {
    // @formatter:off
    CLEAR(FlagEnum.CLEAR, Resources.getString(FlagStatus.class, "clear")), QUERY(FlagEnum.QUERY, Resources.getString(
        FlagStatus.class, "query")), SET(FlagEnum.SET, Resources.getString(FlagStatus.class, "set"));
    // @formatter:on

    private final FlagEnum type;

    private final String label;

    FlagStatus(FlagEnum type, String label) {
        this.type = type;
        this.label = label;
    }

    public FlagEnum getType() {
        return type;
    }

    public String toString() {
        return label;
    }

    public static FlagStatus valueOf(FlagEnum type) {
        FlagStatus result = null;

        for (FlagStatus e : values()) {
            if (e.type == type) {
                result = e;
                break;
            }
        }
        if (result == null) {
            throw new IllegalArgumentException("cannot map " + type + " to a flag status");
        }
        return result;
    }
}
