package org.bidib.wizard.comm;

import org.bidib.jbidibc.enumeration.MotorPortEnum;
import org.bidib.wizard.locale.Resources;

public enum MotorPortStatus implements BidibStatus {
    // @formatter:off
    FORWARD(MotorPortEnum.FORWARD, Resources.getString(MotorPortStatus.class, "forward")), BACKWARD(
        MotorPortEnum.BACKWARD, Resources.getString(MotorPortStatus.class, "backward"));
    // @formatter:on

    private final MotorPortEnum type;

    private final String label;

    MotorPortStatus(MotorPortEnum type, String label) {
        this.type = type;
        this.label = label;
    }

    public MotorPortEnum getType() {
        return type;
    }

    public String toString() {
        return label;
    }

    public static MotorPortStatus valueOf(MotorPortEnum type) {
        MotorPortStatus result = null;

        for (MotorPortStatus e : values()) {
            if (e.type == type) {
                result = e;
                break;
            }
        }
        if (result == null) {
            throw new IllegalArgumentException("cannot map " + type + " to a motor port status");
        }
        return result;
    }
}
