package org.bidib.wizard.comm;

import org.bidib.jbidibc.enumeration.SpeedStepsEnum;

public enum SpeedSteps implements BidibStatus {
    // @formatter:off
    DCC14(14, "14", SpeedStepsEnum.DCC14), DCC28(28, "28", SpeedStepsEnum.DCC28), DCC128(126, "128",
        SpeedStepsEnum.DCC128);
    // @formatter:on

    private final int steps;

    private final String label;

    private final SpeedStepsEnum type;

    SpeedSteps(int steps, String label, SpeedStepsEnum type) {
        this.steps = steps;
        this.label = label;
        this.type = type;
    }

    public int getSteps() {
        return steps;
    }

    public SpeedStepsEnum getType() {
        return type;
    }

    public String toString() {
        return label;
    }

    public static SpeedSteps valueOf(SpeedStepsEnum type) {
        SpeedSteps result = null;

        for (SpeedSteps e : values()) {
            if (e.type == type) {
                result = e;
                break;
            }
        }
        if (result == null) {
            throw new IllegalArgumentException("cannot map " + type + " to a speed step");
        }
        return result;
    }
}
