package org.bidib.wizard.comm;

import org.bidib.jbidibc.enumeration.SwitchPortEnum;
import org.bidib.wizard.locale.Resources;

public enum SwitchPortStatus implements BidibStatus {
    // @formatter:off
    ON(SwitchPortEnum.ON, Resources.getString(SwitchPortStatus.class, "on")), OFF(SwitchPortEnum.OFF, Resources
        .getString(SwitchPortStatus.class, "off"));
    // @formatter:on

    private final SwitchPortEnum type;

    private final String label;

    SwitchPortStatus(SwitchPortEnum type, String label) {
        this.type = type;
        this.label = label;
    }

    public SwitchPortEnum getType() {
        return type;
    }

    public String toString() {
        return label;
    }

    public static SwitchPortStatus valueOf(SwitchPortEnum type) {
        SwitchPortStatus result = null;

        for (SwitchPortStatus e : values()) {
            if (e.type == type) {
                result = e;
                break;
            }
        }
        if (result == null) {
            throw new IllegalArgumentException("cannot map " + type + " to a switch port status");
        }
        return result;
    }
}
