package org.bidib.wizard.dialog;

import java.io.File;

import javax.swing.JFileChooser;
import javax.swing.filechooser.FileFilter;

import org.bidib.wizard.mvc.preferences.model.Preferences;

public abstract class FileDialog {
    public static final int OPEN = JFileChooser.OPEN_DIALOG;

    public static final int SAVE = JFileChooser.SAVE_DIALOG;

    private static File workingDirectory = null;

    static {
        String storedWorkingDirectory = Preferences.getInstance().getWorkingDirectory();

        if (storedWorkingDirectory != null) {
            workingDirectory = new File(storedWorkingDirectory);
        }
    }

    public FileDialog(int dialogType, String fileName, FileFilter filter) {
        final JFileChooser fileChooser = new JFileChooser();

        fileChooser.setAcceptAllFileFilterUsed(false);
        fileChooser.setCurrentDirectory(workingDirectory);
        fileChooser.setDialogType(dialogType);
        fileChooser.setFileFilter(filter);
        fileChooser.setMultiSelectionEnabled(false);
        if (fileName != null) {
            fileChooser.setSelectedFile(new File(workingDirectory, fileName));
        }
        if (fileChooser.showDialog(null, null) == JFileChooser.APPROVE_OPTION) {
            setWorkingDirectory(fileChooser.getCurrentDirectory());
            approve(fileChooser.getSelectedFile().toString());
        }
    }

    public abstract void approve(String fileName);

    private void setWorkingDirectory(File newWorkingDirectory) {
        workingDirectory = newWorkingDirectory;

        Preferences preferences = Preferences.getInstance();

        if (!workingDirectory.toString().equals(preferences.getWorkingDirectory())) {
            preferences.setWorkingDirectory(workingDirectory.toString());
            preferences.save(null);
        }
    }
}
