package org.bidib.wizard.mvc.cvprogrammer.controller;

import java.util.Collection;
import java.util.LinkedList;

import javax.swing.JFrame;

import org.bidib.wizard.mvc.cvprogrammer.controller.listener.CvProgrammerControllerListener;
import org.bidib.wizard.mvc.cvprogrammer.model.CvProgrammerModel;
import org.bidib.wizard.mvc.cvprogrammer.view.CvProgrammerView;
import org.bidib.wizard.mvc.cvprogrammer.view.listener.CvProgrammerViewListener;
import org.bidib.wizard.mvc.main.model.Node;

public class CvProgrammerController {
    private final Collection<CvProgrammerControllerListener> listeners =
        new LinkedList<CvProgrammerControllerListener>();

    private final JFrame parent;

    private final Node node;

    private final int x;

    private final int y;

    private final CvProgrammerModel model = new CvProgrammerModel();

    private CvProgrammerView view = null;

    public CvProgrammerController(JFrame parent, Node node, int x, int y) {
        this.parent = parent;
        this.node = node;
        this.x = x;
        this.y = y;
    }

    public void addCvProgrammerControllerListener(CvProgrammerControllerListener l) {
        listeners.add(l);
    }

    private void fireClose() {
        for (CvProgrammerControllerListener l : listeners) {
            l.close();
        }
    }

    private void fireRead(int cvNumber) {
        for (CvProgrammerControllerListener l : listeners) {
            l.read(node, cvNumber);
        }
    }

    private void fireWrite(int cvNumber, int cvValue) {
        for (CvProgrammerControllerListener l : listeners) {
            l.write(node, cvNumber, cvValue);
        }
    }

    public void start() {
        view = new CvProgrammerView(parent, model, x, y);
        view.addCvProgrammerViewListener(new CvProgrammerViewListener() {
            @Override
            public void close() {
                fireClose();
            }

            @Override
            public void read(int cvNumber) {
                fireRead(cvNumber);
            }

            @Override
            public void write(int cvNumber, int cvValue) {
                fireWrite(cvNumber, cvValue);
            }
        });
    }

    public void writeCvValue(int cvValue) {
        model.setValue(cvValue);
    }
}
