package org.bidib.wizard.mvc.firmware.model;

import java.util.Collection;
import java.util.LinkedList;

import org.bidib.wizard.mvc.firmware.model.listener.FirmwareModelListener;

public class FirmwareModel {
    private final Collection<FirmwareModelListener> listeners = new LinkedList<FirmwareModelListener>();

    private boolean inProgress = false;

    private int progressValue = 0;

    private String uniqueId = null;

    private String version = null;

    public void addFirmwareModelListener(FirmwareModelListener l) {
        listeners.add(l);
    }

    public void removeFirmwareModelListener(FirmwareModelListener l) {
        listeners.remove(l);
    }

    public boolean isInProgress() {
        return inProgress;
    }

    public void setInProgress(boolean inProgress) {
        if (this.inProgress != inProgress) {
            this.inProgress = inProgress;
            fireInProgressChanged(inProgress);
        }
    }

    public int getProgressValue() {
        return progressValue;
    }

    public void setProgressValue(int progressValue) {
        if (this.progressValue != progressValue) {
            this.progressValue = progressValue;
            fireProgressChanged(progressValue);
        }
    }

    public String getUniqueId() {
        return uniqueId;
    }

    public void setUniqueId(String uniqueId) {
        this.uniqueId = uniqueId;
    }

    public String getVersion() {
        return version;
    }

    public void setVersion(String version) {
        this.version = version;
    }

    private void fireInProgressChanged(boolean inProgress) {
        for (FirmwareModelListener l : listeners) {
            l.inProgressChanged(inProgress);
        }
    }

    private void fireProgressChanged(int progressValue) {
        for (FirmwareModelListener l : listeners) {
            l.progressValueChanged(progressValue);
        }
    }
}
