package org.bidib.wizard.mvc.firmware.view.panel;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import org.bidib.wizard.locale.Resources;
import org.bidib.wizard.mvc.firmware.model.FirmwareModel;

public class FirmwareInfoPanel extends JPanel {
    private static final long serialVersionUID = -1164126691320954536L;

    private final JLabel uniqueIdLabel = new JLabel(Resources.getString(getClass(), "uuid") + ":");

    private final JTextField uniqueId = new JTextField();

    private final Component glue = Box.createGlue();

    private final JTextField version = new JTextField();

    public FirmwareInfoPanel(FirmwareModel model) {
        setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(), Resources.getString(getClass(),
            "title")
            + ":"));
        setLayout(new GridBagLayout());

        GridBagConstraints c = new GridBagConstraints();

        c.anchor = GridBagConstraints.FIRST_LINE_START;
        c.fill = GridBagConstraints.HORIZONTAL;
        c.gridx = 0;
        c.gridy = 0;
        c.insets = new Insets(5, 5, 5, 5);
        add(uniqueIdLabel, c);

        uniqueId.setEditable(false);
        uniqueId.setText(model.getUniqueId());
        c.gridx++;
        c.weightx = 1;
        add(uniqueId, c);

        c.gridx++;
        c.weightx = 0;
        add(glue, c);

        c.gridx = 0;
        c.gridy++;
        add(new JLabel(Resources.getString(getClass(), "version") + ":"), c);

        version.setEditable(false);
        version.setText(model.getVersion());
        c.gridx++;
        c.weightx = 1;
        add(version, c);
    }

    public void setButtonWidth(int width) {
        glue.setPreferredSize(new Dimension(width, glue.getSize().height));
    }

    public int getLabelWidth() {
        return uniqueIdLabel.getWidth();
    }

    public void setLabelWidth(int width) {
        uniqueIdLabel.setPreferredSize(new Dimension(width, uniqueIdLabel.getSize().height));
    }

    public void setTextWidth(int width) {
        uniqueId.setPreferredSize(new Dimension(width, uniqueId.getSize().height));
        version.setPreferredSize(new Dimension(width, version.getSize().height));
    }
}
