package org.bidib.wizard.mvc.main.model;

import java.beans.XMLDecoder;
import java.beans.XMLEncoder;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Collection;
import java.util.List;
import java.util.Vector;
import java.util.zip.GZIPInputStream;
import java.util.zip.GZIPOutputStream;

public class NodeState {
    private List<Accessory> accessories = null;

    private List<LightPort> lightPorts = null;

    private List<Macro> macros = null;

    private List<ServoPort> servoPorts = null;

    public NodeState() {
    }

    public NodeState(Collection<Accessory> accessories, Collection<LightPort> lightPorts, Collection<Macro> macros,
        Collection<ServoPort> servoPorts) {
        setAccessories(accessories);
        setLightPorts(lightPorts);
        setMacros(macros);
        setServoPorts(servoPorts);
    }

    public Collection<Accessory> getAccessories() {
        return accessories;
    }

    public void setAccessory(int index, Accessory accessory) {
        accessories.set(index, accessory);
    }

    public void setAccessories(Collection<Accessory> accessories) {
        this.accessories = new Vector<Accessory>(accessories);
    }

    public Collection<LightPort> getLightPorts() {
        return lightPorts;
    }

    public void setLightPort(int index, LightPort lightPort) {
        lightPorts.set(index, lightPort);
    }

    public void setLightPorts(Collection<LightPort> lightPorts) {
        this.lightPorts = new Vector<LightPort>(lightPorts);
    }

    public Collection<Macro> getMacros() {
        return macros;
    }

    public void setMacro(int index, Macro macro) {
        macros.set(index, macro);
    }

    public void setMacros(Collection<Macro> macros) {
        this.macros = new Vector<Macro>(macros);
    }

    public Collection<ServoPort> getServoPorts() {
        return servoPorts;
    }

    public void setServoPort(int index, ServoPort servoPort) {
        servoPorts.set(index, servoPort);
    }

    public void setServoPorts(Collection<ServoPort> servoPorts) {
        this.servoPorts = new Vector<ServoPort>(servoPorts);
    }

    public static NodeState load(String fileName) {
        NodeState result = null;
        XMLDecoder d = null;

        try {
            try {
                d = new XMLDecoder(new GZIPInputStream(new BufferedInputStream(new FileInputStream(fileName))));

                result = (NodeState) d.readObject();
            }
            catch (IOException e) {
                d = new XMLDecoder(new BufferedInputStream(new FileInputStream(fileName)));

                result = (NodeState) d.readObject();
            }
        }
        catch (FileNotFoundException e) {
        }
        finally {
            if (d != null) {
                d.close();
            }
        }
        return result;
    }

    public void save(String fileName) throws IOException {
        XMLEncoder e = new XMLEncoder(new GZIPOutputStream(new BufferedOutputStream(new FileOutputStream(fileName))));

        e.writeObject(this);
        e.close();
    }
}
