package org.bidib.wizard.mvc.main.model.function;

import org.bidib.wizard.comm.SwitchPortStatus;
import org.bidib.wizard.mvc.main.model.SwitchPort;

public class SwitchPortAction extends PortAction {
    public SwitchPortAction() {
        setAction(SwitchPortStatus.ON);
    }

    public SwitchPortAction(SwitchPortStatus action, int delay, SwitchPort port) {
        setAction(action);
        setDelay(delay);
        setPort(port);
    }

    public SwitchPortStatus getAction() {
        return (SwitchPortStatus) super.getAction();
    }

    public void setAction(SwitchPortStatus action) {
        super.setAction(action);
    }

    public SwitchPort getPort() {
        return (SwitchPort) super.getPort();
    }

    public void setPort(SwitchPort port) {
        super.setPort(port);
    }

    public String getDebugString() {
        int id = 0;

        if (getPort() != null) {
            id = getPort().getId();
        }
        return "@" + getDelay() + " S-Port:" + String.format("%02d", id) + "->" + getAction().name().toLowerCase();
    }
}
