package org.bidib.wizard.mvc.main.view.component;

import java.awt.Point;
import java.awt.event.MouseEvent;

import javax.swing.JList;

import org.apache.commons.lang.StringUtils;
import org.bidib.wizard.locale.Resources;
import org.bidib.wizard.mvc.main.model.LabelAware;

public class LabelList extends JList<Object> {
    private static final long serialVersionUID = -8239741835957395082L;

    public int getIndex(Point point) {
        return locationToIndex(point);
    }

    public String getToolTipText(MouseEvent e) {
        String result = null;
        Point p = e.getPoint();
        int row = getIndex(p);

        if (row >= 0 && row < getModel().getSize()) {
            Object object = getModel().getElementAt(row);

            if (object != null) {
                String label = null;

                if (object instanceof LabelAware) {
                    label = ((LabelAware) object).getLabel();
                }

                if (StringUtils.isBlank(label)) {
                    // no label assigned, prepare tootip
                    result = Resources.getString(LabelList.class, "chooseLabel");
                }
            }
        }
        return result;
    }

    @Override
    public String toString() {

        return getClass().getName();
    }
}
