package org.bidib.wizard.mvc.main.view.menu;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Collection;
import java.util.LinkedList;

import javax.swing.JMenuItem;

import org.bidib.wizard.locale.Resources;
import org.bidib.wizard.mvc.main.view.menu.listener.AccessoryListMenuListener;

public class AccessoryListMenu extends MyPopupMenu {
    private static final long serialVersionUID = 4174194100632344757L;

    private final Collection<AccessoryListMenuListener> menuListeners = new LinkedList<AccessoryListMenuListener>();

    public AccessoryListMenu() {
        JMenuItem editLabel = new JMenuItem(Resources.getString(getClass(), "editLabel") + " ...");

        editLabel.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                fireEditLabel();
            }
        });
        add(editLabel);

        addSeparator();

        JMenuItem imp = new JMenuItem(Resources.getString(getClass(), "import") + " ...");

        imp.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                fireImport();
            }
        });
        add(imp);

        JMenuItem export = new JMenuItem(Resources.getString(getClass(), "export") + " ...");

        export.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                fireExport();
            }
        });
        add(export);
    }

    public void addMenuListener(AccessoryListMenuListener l) {
        menuListeners.add(l);
    }

    private void fireEditLabel() {
        for (AccessoryListMenuListener l : menuListeners) {
            l.editLabel();
        }
    }

    private void fireExport() {
        for (AccessoryListMenuListener l : menuListeners) {
            l.exportAccessory();
        }
    }

    private void fireImport() {
        for (AccessoryListMenuListener l : menuListeners) {
            l.importAccessory();
        }
    }
}
