package org.bidib.wizard.mvc.main.view.menu;

import java.awt.Dimension;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;

public class MyPopupMenu extends JPopupMenu implements MouseListener {
    private static final long serialVersionUID = 9087737730428228783L;

    @Override
    public void addSeparator() {
        add(new Separator());
    }

    @Override
    public JMenuItem add(JMenuItem menuItem) {
        menuItem.addMouseListener(this);
        return super.add(menuItem);
    }

    @Override
    public void mouseEntered(MouseEvent e) {
        ((JMenuItem) e.getSource()).setArmed(true);
    }

    @Override
    public void mouseExited(MouseEvent e) {
        ((JMenuItem) e.getSource()).setArmed(false);
    }

    @Override
    public void mouseClicked(MouseEvent e) {
    }

    @Override
    public void mousePressed(MouseEvent e) {
    }

    @Override
    public void mouseReleased(MouseEvent e) {
    }

    public static final class Separator extends JPopupMenu.Separator {
        private static final long serialVersionUID = -9193738046541029912L;

        public Dimension getPreferredSize() {
            Dimension d = super.getPreferredSize();

            if (d.height == 0) {
                d.height = 4;
            }
            return d;
        }
    }
}
