package org.bidib.wizard.mvc.main.view.panel;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.JPanel;
import javax.swing.event.ListSelectionListener;

import org.bidib.wizard.mvc.main.model.MainModel;
import org.bidib.wizard.mvc.main.model.listener.LightPortListener;
import org.bidib.wizard.mvc.main.model.listener.OutputListener;
import org.bidib.wizard.mvc.main.model.listener.PortListener;
import org.bidib.wizard.mvc.main.model.listener.ServoPortListener;
import org.bidib.wizard.mvc.main.view.panel.listener.AccessoryListListener;
import org.bidib.wizard.mvc.main.view.panel.listener.AccessoryTableListener;
import org.bidib.wizard.mvc.main.view.panel.listener.MacroListListener;
import org.bidib.wizard.mvc.main.view.panel.listener.MacroTableListener;
import org.bidib.wizard.mvc.main.view.panel.listener.NodeListListener;
import org.bidib.wizard.mvc.main.view.panel.listener.StatusListener;

public class MainPanel extends JPanel {
    private static final long serialVersionUID = -2338728633301466542L;

    private final StatusPanel statusPanel;

    private final NodePanel nodePanel;

    public MainPanel(MainModel model) {
        statusPanel = new StatusPanel(model.getStatusModel());
        nodePanel = new NodePanel(model);
        setLayout(new GridBagLayout());

        GridBagConstraints c = new GridBagConstraints();

        c.anchor = GridBagConstraints.FIRST_LINE_START;
        c.fill = GridBagConstraints.BOTH;
        c.gridx = 0;
        c.gridy = 0;
        c.weightx = 1;
        c.weighty = 0;
        add(statusPanel, c);

        c.anchor = GridBagConstraints.LINE_START;
        c.gridy++;
        c.insets = new Insets(5, 5, 5, 5);
        c.weighty = 1;
        add(nodePanel, c);
    }

    public void addAccessoryListListener(AccessoryListListener l) {
        nodePanel.addAccessoryListListener(l);
    }

    public void addAccessoryListSelectionListener(ListSelectionListener l) {
        nodePanel.addAccessoryListSelectionListener(l);
    }

    public void addAccessoryTableListener(AccessoryTableListener l) {
        nodePanel.addAccessoryTableListener(l);
    }

    public void addAnalogPortListener(OutputListener l) {
        nodePanel.addAnalogPortListener(l);
    }

    public void addBoosterStatusListener(StatusListener l) {
        nodePanel.addBoosterStatusListener(l);
    }

    public void addInputPortListener(PortListener l) {
        nodePanel.addInputPortListener(l);
    }

    public void addLightPortListener(LightPortListener l) {
        nodePanel.addLightPortListener(l);
    }

    public void addMacroListListener(MacroListListener l) {
        nodePanel.addMacroListListener(l);
    }

    public void addMacroListSelectionListener(ListSelectionListener l) {
        nodePanel.addMacroListSelectionListener(l);
    }

    public void addMacroTableListener(MacroTableListener l) {
        nodePanel.addMacroTableListener(l);
    }

    public void addMotorPortListener(OutputListener l) {
        nodePanel.addMotorPortListener(l);
    }

    public void addNodeListListener(NodeListListener l) {
        nodePanel.addNodeListListener(l);
    }

    public void addNodeListSelectionListener(ListSelectionListener l) {
        nodePanel.addNodeListSelectionListener(l);
    }

    public void addServoPortListener(ServoPortListener l) {
        nodePanel.addServoPortListener(l);
    }

    public void addSoundPortListener(OutputListener l) {
        nodePanel.addSoundPortListener(l);
    }

    public void addStatusListener(StatusListener l) {
        statusPanel.addStatusListener(l);
    }

    public void addSwitchPortListener(OutputListener l) {
        nodePanel.addSwitchPortListener(l);
    }
}
