package org.bidib.wizard.mvc.main.view.panel;

import javax.swing.table.TableColumn;

import org.bidib.wizard.comm.MotorPortStatus;
import org.bidib.wizard.locale.Resources;
import org.bidib.wizard.mvc.main.model.MainModel;
import org.bidib.wizard.mvc.main.model.SimplePortTableModel;
import org.bidib.wizard.mvc.main.view.table.ComboBoxWithButtonEditor;
import org.bidib.wizard.mvc.main.view.table.ComboBoxWithButtonRenderer;

public class MotorPortListPanel extends SimplePortListPanel {
    private static final long serialVersionUID = 5155673933589361071L;

    public MotorPortListPanel(MainModel model) {
        super(new SimplePortTableModel(), model.getMotorPorts(), Resources.getString(MotorPortListPanel.class,
            "emptyTable"));
        model.addMotorPortListListener(this);

        TableColumn buttonColumn = table.getColumnModel().getColumn(table.getColumnCount() - 1);

        buttonColumn.setCellRenderer(new ComboBoxWithButtonRenderer(table.getActions(MotorPortStatus.FORWARD), ">"));
        buttonColumn.setCellEditor(new ComboBoxWithButtonEditor(table.getActions(MotorPortStatus.FORWARD), ">"));
    }
}
