package org.bidib.wizard.mvc.main.view.panel;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.BorderFactory;
import javax.swing.JPanel;
import javax.swing.JSplitPane;
import javax.swing.event.ListSelectionListener;

import org.bidib.wizard.locale.Resources;
import org.bidib.wizard.mvc.main.model.MainModel;
import org.bidib.wizard.mvc.main.model.listener.LightPortListener;
import org.bidib.wizard.mvc.main.model.listener.OutputListener;
import org.bidib.wizard.mvc.main.model.listener.PortListener;
import org.bidib.wizard.mvc.main.model.listener.ServoPortListener;
import org.bidib.wizard.mvc.main.view.panel.listener.AccessoryListListener;
import org.bidib.wizard.mvc.main.view.panel.listener.AccessoryTableListener;
import org.bidib.wizard.mvc.main.view.panel.listener.MacroListListener;
import org.bidib.wizard.mvc.main.view.panel.listener.MacroTableListener;
import org.bidib.wizard.mvc.main.view.panel.listener.NodeListListener;
import org.bidib.wizard.mvc.main.view.panel.listener.StatusListener;

public class NodePanel extends JPanel {
    private static final long serialVersionUID = -8668618688820184387L;

    private final NodeListPanel nodeListPanel;

    private final TabPanel tabPanel;

    public NodePanel(MainModel model) {
        setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(), Resources.getString(getClass(),
            "title")
            + ":"));
        nodeListPanel = new NodeListPanel(model);
        tabPanel = new TabPanel(model);
        setLayout(new GridBagLayout());

        JSplitPane splitPane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, nodeListPanel, tabPanel);

        splitPane.setContinuousLayout(true);
        splitPane.setOneTouchExpandable(true);

        GridBagConstraints c = new GridBagConstraints();

        c.anchor = GridBagConstraints.FIRST_LINE_START;
        c.fill = GridBagConstraints.BOTH;
        c.insets = new Insets(5, 5, 5, 5);
        c.weightx = 1;
        c.weighty = 1;

        add(splitPane, c);
    }

    public void addAccessoryListListener(AccessoryListListener l) {
        tabPanel.addAccessoryListListener(l);
    }

    public void addAccessoryListSelectionListener(ListSelectionListener l) {
        tabPanel.addAccessoryListSelectionListener(l);
    }

    public void addAccessoryTableListener(AccessoryTableListener l) {
        tabPanel.addAccessoryTableListener(l);
    }

    public void addAnalogPortListener(OutputListener l) {
        tabPanel.addAnalogPortListener(l);
    }

    public void addBoosterStatusListener(StatusListener l) {
        tabPanel.addBoosterStatusListener(l);
    }

    public void addInputPortListener(PortListener l) {
        tabPanel.addInputPortListener(l);
    }

    public void addLightPortListener(LightPortListener l) {
        tabPanel.addLightPortListener(l);
    }

    public void addMacroListListener(MacroListListener l) {
        tabPanel.addMacroListListener(l);
    }

    public void addMacroListSelectionListener(ListSelectionListener l) {
        tabPanel.addMacroListSelectionListener(l);
    }

    public void addMacroTableListener(MacroTableListener l) {
        tabPanel.addMacroTableListener(l);
    }

    public void addMotorPortListener(OutputListener l) {
        tabPanel.addMotorPortListener(l);
    }

    public void addNodeListListener(NodeListListener l) {
        nodeListPanel.addNodeListListener(l);
    }

    public void addNodeListSelectionListener(ListSelectionListener l) {
        nodeListPanel.addListSelectionListener(l);
    }

    public void addServoPortListener(ServoPortListener l) {
        tabPanel.addServoPortListener(l);
    }

    public void addSoundPortListener(OutputListener l) {
        tabPanel.addSoundPortListener(l);
    }

    public void addSwitchPortListener(OutputListener l) {
        tabPanel.addSwitchPortListener(l);
    }
}
