package org.bidib.wizard.mvc.main.view.panel;

import java.util.Dictionary;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

public abstract class SliderPanel extends JPanel {
    private static final long serialVersionUID = 2664530878068811667L;

    private static final String INFINITY = "\u221e";

    private final JSlider slider;

    private final JLabel sliderLabel = new JLabel();

    public SliderPanel(String title, int min, int max, int value, boolean inverted) {
        setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(), title));
        setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
        slider = new JSlider(
            JSlider.HORIZONTAL) {
            private static final long serialVersionUID = -7372719801568758303L;

            @Override
            public Dictionary<?, ?> getLabelTable() {
                Dictionary<?, ?> result = super.getLabelTable();

                if (result != null) {
                    JLabel label = (JLabel) result.get(0);

                    if (label != null) {
                        label.setText(INFINITY);
                    }
                }
                return result;
            }
        };
        slider.addChangeListener(new ChangeListener() {
            @Override
            public void stateChanged(ChangeEvent e) {
                SliderPanel.this.stateChanged(e);
            }
        });
        slider.setInverted(inverted);
        slider.setMajorTickSpacing(max - min);
        slider.setMaximum(max);
        slider.setMinimum(min);
        slider.setMinorTickSpacing(16);
        slider.setPaintLabels(true);
        slider.setPaintTicks(true);
        slider.setValue(value);
        add(Box.createVerticalGlue());
        add(slider);
        add(Box.createVerticalGlue());
        sliderLabel.setText(String.valueOf(value));
        add(sliderLabel);
    }

    public void setLabel(int label) {
        sliderLabel.setText(label != 0 ? String.valueOf(label) : INFINITY);
    }

    public void setValue(int value) {
        slider.setValue(value);
    }

    public abstract void stateChanged(ChangeEvent e);
}
