package org.bidib.wizard.mvc.main.view.panel;

import javax.swing.table.TableColumn;

import org.bidib.wizard.comm.SoundPortStatus;
import org.bidib.wizard.locale.Resources;
import org.bidib.wizard.mvc.main.model.MainModel;
import org.bidib.wizard.mvc.main.model.SimplePortTableModel;
import org.bidib.wizard.mvc.main.view.table.ComboBoxWithButtonEditor;
import org.bidib.wizard.mvc.main.view.table.ComboBoxWithButtonRenderer;

public class SoundPortListPanel extends SimplePortListPanel {
    private static final long serialVersionUID = -1187034791874245734L;

    public SoundPortListPanel(MainModel model) {
        super(new SimplePortTableModel(), model.getSoundPorts(), Resources.getString(SoundPortListPanel.class,
            "emptyTable"));
        model.addSoundPortListListener(this);

        TableColumn buttonColumn = table.getColumnModel().getColumn(table.getColumnCount() - 1);

        buttonColumn.setCellRenderer(new ComboBoxWithButtonRenderer(table.getActions(SoundPortStatus.START), ">"));
        buttonColumn.setCellEditor(new ComboBoxWithButtonEditor(table.getActions(SoundPortStatus.START), ">"));
    }
}
