package org.bidib.wizard.mvc.main.view.panel;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.util.Date;

import javax.swing.BorderFactory;
import javax.swing.JPanel;

import org.bidib.wizard.locale.Resources;
import org.bidib.wizard.mvc.main.model.StatusModel;
import org.bidib.wizard.mvc.main.model.listener.StatusListener;
import org.bidib.wizard.mvc.main.view.component.DigitalClock;
import org.bidib.wizard.mvc.preferences.model.Preferences;
import org.bidib.wizard.mvc.preferences.model.listener.PreferencesListener;

public class TimePanel extends JPanel {
    private static final long serialVersionUID = -5165845501678901031L;

    public TimePanel(StatusModel model) {
        setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(), Resources.getString(getClass(),
            "title")
            + ":"));
        setLayout(new GridBagLayout());

        final DigitalClock clock =
            new DigitalClock(Preferences.getInstance().getStartTime(), Preferences.getInstance().getTimeFactor());

        if (model.isRunning()) {
            clock.start();
        }

        GridBagConstraints c = new GridBagConstraints();

        c.anchor = GridBagConstraints.CENTER;
        c.fill = GridBagConstraints.BOTH;
        // for analog clock
        // c.weightx = 1;
        // c.weighty = 1;
        add(clock, c);

        model.addStatusListener(new StatusListener() {
            @Override
            public void cdChanged(boolean cd) {
            }

            @Override
            public void runningChanged(boolean running) {
                if (running) {
                    clock.start();
                }
                else {
                    clock.stop();
                }
            }

            @Override
            public void rxChanged(boolean rx) {
            }

            @Override
            public void txChanged(boolean tx) {
            }
        });
        Preferences.getInstance().addPreferencesListener(new PreferencesListener() {
            @Override
            public void commPortChanged(String commPort) {
            }

            @Override
            public void mockChanged(boolean mock) {
            }

            @Override
            public void startTimeChanged(Date startTime) {
                clock.setStartTime(startTime);
            }

            @Override
            public void timeFactorChanged(int timeFactor) {
                clock.setTimeFactor(timeFactor);
            }
        });
    }
}