package org.bidib.wizard.mvc.main.view.panel.listener;

import org.bidib.wizard.mvc.main.model.Macro;

public interface MacroListListener extends LabelChangedListener {
    void exportMacro(Macro macro);

    void importMacro();

    void reloadMacro(Macro macro);

    /**
     * Write the macro to the node into persistent memory.
     * @param macro the macro
     */
    void saveMacro(Macro macro);

    void startMacro(Macro macro);

    void stopMacro(Macro macro);

    /**
     * Clear the entries of the macro and set default values for cycles.
     * @param macro the macro
     */
    void initializeMacro(Macro macro);

    /**
     * Write the macro to the node into transient memory.
     * @param macro the macro
     */
    void transferMacro(Macro macro);
}
