package org.bidib.wizard.mvc.main.view.table;

import java.awt.Component;
import java.text.DecimalFormat;

import javax.swing.DefaultCellEditor;
import javax.swing.JFormattedTextField;
import javax.swing.JTable;
import javax.swing.SwingConstants;
import javax.swing.text.DefaultFormatterFactory;
import javax.swing.text.NumberFormatter;

public class NumberCellEditor extends DefaultCellEditor {
    private static final long serialVersionUID = -4637292707728673171L;

    private final NumberFormatter formatter = new NumberFormatter(
        new DecimalFormat("#")) {
        private static final long serialVersionUID = 9071735589476805065L;

        {
            setAllowsInvalid(false);
            setMaximum(255);
            setMinimum(0);
        }
    };

    public NumberCellEditor() {
        super(new JFormattedTextField());
    }

    public Component getTableCellEditorComponent(JTable table, Object value, boolean isSelected, int row, int column) {
        JFormattedTextField editor =
            (JFormattedTextField) super.getTableCellEditorComponent(table, value, isSelected, row, column);

        editor.setFormatterFactory(new DefaultFormatterFactory(formatter, formatter, formatter));
        editor.setHorizontalAlignment(SwingConstants.RIGHT);
        return editor;
    }
}
