package org.bidib.wizard.mvc.preferences.view.listener;

import java.util.Date;

public interface PreferencesViewListener {
    /**
     * The comm port has changed.
     * @param port the new comm port value
     */
    void commPortChanged(String port);

    /**
     * The mock selection has changed.
     * @param mock the new mock value
     */
    void mockChanged(boolean mock);

    /**
     * User pressed save.
     */
    void save();

    /**
     * User pressed cancel.
     */
    void cancel();

    /**
     * The start time has changed.
     * @param startTime the new start time value
     */
    void startTimeChanged(Date startTime);

    /**
     * The time factor has changed.
     * @param timeFactor the new time factor value
     */
    void timeFactorChanged(int timeFactor);
}
